/////////////////////////////////////////////////////////////////////////////
//  Copyright (C) 2002 Ultr@VNC. All Rights Reserved.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
//  USA.
//
// If the source code for the program is not available from the place from
// which you received this file, check 
// http://ultravnc.sourceforge.net/
//
////////////////////////////////////////////////////////////////////////////
//
// IF YOU USE THIS GPL SOURCE CODE TO MAKE YOUR DSM PLUGIN, PLEASE ADD YOUR
// COPYRIGHT TO THE TOP OF THIS FILE AND SHORTLY DESCRIBE/EXPLAIN THE 
// MODIFICATIONS YOU'VE MADE. THANKS.
//
// IF YOU DON'T USE THIS CODE AS A BASE FOR YOUR PLUGIN, THE HEADER ABOVE AND
// ULTR@VNC COPYRIGHT SHOULDN'T BE FOUND IN YOUR PLUGIN SOURCE CODE.
//
////////////////////////////////////////////////////////////////////////////
//
// UltraRC4Plugin C^[tF[X
// 
// Copyright(C) 2009 K_Yaguchi.
// All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#include "UltraRC4Plugin.h"




// ------------------------------------------------------------------------------------------------------
// RXgN^
// ------------------------------------------------------------------------------------------------------
IUltraRC4Plugin::IUltraRC4Plugin(const BYTE* pKeyData)
{
	memset(&m_TransBuffer, 0, sizeof(PLGBUFFER));
	memset(&m_RestBuffer, 0, sizeof(PLGBUFFER));
	memset(&m_rc4Trans, 0, sizeof(RC4STATE));
	memset(&m_rc4Rest, 0, sizeof(RC4STATE));

	rc4_setup(&m_rc4Trans, pKeyData, URC4KEYLEN);
	rc4_setup(&m_rc4Rest , pKeyData, URC4KEYLEN);
	LOG("IUltraRC4Plugin::IUltraRC4Plugin\n");
}

// ------------------------------------------------------------------------------------------------------
// fXgN^
// ------------------------------------------------------------------------------------------------------
IUltraRC4Plugin::~IUltraRC4Plugin()
{
	delete [] m_TransBuffer.pBuffer;
	delete [] m_RestBuffer.pBuffer;
	LOG("IUltraRC4Plugin::~IUltraRC4Plugin %p %p\n", m_TransBuffer.pBuffer, m_RestBuffer.pBuffer);
}

// ------------------------------------------------------------------------------------------------------
// TransformBuffer
// ------------------------------------------------------------------------------------------------------
BYTE* IUltraRC4Plugin::TransformBuffer(BYTE* pDataBuffer, int nDataLen, int* pnTransformedDataLen)
{
	if( nDataLen < 0 )
	{
		LOG("TransformBuffer %d\n",nDataLen);
		nDataLen = 0;
	}

	// obt@m
	int ret = PluginMallocBuffer(&m_TransBuffer, nDataLen);
	if( ret < 0 )
	{
		*pnTransformedDataLen = 0;
		return NULL;
	}

	// ϊ
//	for(int i=0; i < nDataLen; i++)
//		m_TransBuffer.pBuffer[i] = pDataBuffer[i]^0xaa;
	rc4_crypt(&m_rc4Trans, pDataBuffer, nDataLen, m_TransBuffer.pBuffer);

	*pnTransformedDataLen = nDataLen;

	BIN(pDataBuffer, nDataLen,1);
	//LOG("IUltraRC4Plugin::TransformBuffer    %-10d%02x %02x\n", nDataLen, *pDataBuffer, *m_TransBuffer.pBuffer);
	return m_TransBuffer.pBuffer;
}

// ------------------------------------------------------------------------------------------------------
// RestoreBuffer
// ------------------------------------------------------------------------------------------------------
BYTE* IUltraRC4Plugin::RestoreBuffer(BYTE* pRestoredDataBuffer, int nDataLen, int* pnRestoredDataLen)
{
	// obt@m
	if( pRestoredDataBuffer==NULL )
	{
		*pnRestoredDataLen = nDataLen;
		PluginMallocBuffer(&m_RestBuffer, nDataLen);
		return m_RestBuffer.pBuffer;
	}

	// ϊ
//	for(int i=0; i < nDataLen; i++)
//		pRestoredDataBuffer[i] = m_RestBuffer.pBuffer[i]^0xaa;
	rc4_crypt(&m_rc4Rest, m_RestBuffer.pBuffer, nDataLen, pRestoredDataBuffer);

	*pnRestoredDataLen = nDataLen;

	BIN(pRestoredDataBuffer, nDataLen,0);
	//LOG("IUltraRC4Plugin::RestoreBuffer      %-10d%02x %02x\n", nDataLen, *m_RestBuffer.pBuffer, *pRestoredDataBuffer);
	return m_RestBuffer.pBuffer;
}

